"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GwasAssociationStudy(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import opencb as opencb_2_9_3

        return {
            "traits": opencb_2_9_3.GwasAssociationStudyTrait,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.avro.GwasAssociationStudyTrait": opencb_2_9_3.GwasAssociationStudyTrait,
            "org.opencb.biodata.models.variant.avro.GwasAssociationStudy": opencb_2_9_3.GwasAssociationStudy,
        }

    __slots__ = [
        "genotypingTechnology",
        "initialSampleSize",
        "initialSampleSizeDescription",
        "platform",
        "pubmedid",
        "study",
        "studyAccession",
        "traits",
    ]

    def __init__(
        self,
        genotypingTechnology=None,
        initialSampleSize=None,
        initialSampleSizeDescription=None,
        platform=None,
        pubmedid=None,
        study=None,
        studyAccession=None,
        traits=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.GwasAssociationStudy model.

        :param genotypingTechnology:
        :type genotypingTechnology: None | str
        :param initialSampleSize:
        :type initialSampleSize: None | int
        :param initialSampleSizeDescription:
        :type initialSampleSizeDescription: None | str
        :param platform:
        :type platform: None | str
        :param pubmedid:
        :type pubmedid: None | str
        :param study:
        :type study: None | str
        :param studyAccession:
        :type studyAccession: None | str
        :param traits:
        :type traits: None | list[GwasAssociationStudyTrait]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
